{
    Файл является частью библиотеки RubiRobot

    © 2017 Слинкин Д.А.

    Обработка кнопок контроллера Lego EV3

    Подробная информация о лицензировании находится в файле README,
    входящем в состав библиотеки.

    ДАННОЕ ПРОГРАММНОЕ ОБЕСПЕЧЕНИЕ ПРЕДОСТАВЛЯЕТСЯ «КАК ЕСТЬ», БЕЗ
    КАКИХ-ЛИБО ГАРАНТИЙ, ЯВНО ВЫРАЖЕННЫХ ИЛИ ПОДРАЗУМЕВАЕМЫХ,
    ВКЛЮЧАЯ ГАРАНТИИ ТОВАРНОЙ ПРИГОДНОСТИ, СООТВЕТСТВИЯ ПО ЕГО
    КОНКРЕТНОМУ НАЗНАЧЕНИЮ И ОТСУТСТВИЯ НАРУШЕНИЙ, НО НЕ ОГРАНИЧИВАЯСЬ 
    ИМИ. НИ В КАКОМ СЛУЧАЕ АВТОРЫ ИЛИ ПРАВООБЛАДАТЕЛИ НЕ НЕСУТ
    ОТВЕТСТВЕННОСТИ ПО КАКИМ-ЛИБО ИСКАМ, ЗА УЩЕРБ ИЛИ ПО ИНЫМ ТРЕБОВАНИЯМ,
    В ТОМ ЧИСЛЕ, ПРИ ДЕЙСТВИИ КОНТРАКТА, ДЕЛИКТЕ ИЛИ ИНОЙ СИТУАЦИИ,
    ВОЗНИКШИМ ИЗ-ЗА ИСПОЛЬЗОВАНИЯ ПРОГРАММНОГО ОБЕСПЕЧЕНИЯ ИЛИ ИНЫХ
    ДЕЙСТВИЙ С ПРОГРАММНЫМ ОБЕСПЕЧЕНИЕМ.

 **********************************************************************}


{$SMARTLINK ON}
{$mode objfpc}
{$H+}

unit rubiroButtons;

interface
uses uev3,BaseUnix;

const
      bBACK = 14;
      bCENTER = 28;
      bUP = 103;
      bLEFT = 105;
      bRIGHT = 106;
      bDOWN = 108;

type

    { TEv3Buttons }

    TEv3Buttons=class(TEv3)
      private
       const
        KEY_MAX = $2ff;
        BUF_LEN = (KEY_MAX + 7) div 8;
       var
        fbytes:array[0..BUF_LEN-1]of byte;
        fi:cint;
      private
        function testbit(bit:byte):boolean;
        procedure testButtons();
      private
        function getBack: variant;
        function getCenter: variant;
        function getDown: variant;
        function getLeft: variant;
        function getRight: variant;
        function getUp: variant;
      public
       class function varToButton(button:variant):integer;
       class function ParseEvent(event:string; out Button:integer; out Press:boolean):string;
       class function createEvent(Button:integer; Press:boolean):string;
      public
       constructor Create();
       destructor destroy;override;
       // события вида '14:0','назад:нет'  (отпускание Back) или '108:1','Down:NO' (нажатие клавиши Down)
       function waitEvent(event:string; timeout:dword=high(dword)):boolean; override;
       // блокированно ждать нажатия-отпускания и возвратить
       function wait(out Button:variant; out Press:variant):TEv3Buttons;
       // псевдоблокированно ждать нажатия-отпускания набора кнопок
       function waitAll(Buttons:array of const):TEv3Buttons;
       function waitAny(Buttons:array of const):TEv3Buttons;
       property Back:variant read getBack;
       property Center:variant read getCenter;
       property Up:variant read getUp;
       property Left:variant read getLeft;
       property Right:variant read getRight;
       property Down:variant read getDown;
    end;

var ev3buttons:TEv3Buttons;
implementation
uses
  SysUtils,Unix,uev3func,strutils,dateutils,uev3utf8;

{ TEv3Buttons }

function TEv3Buttons.testbit(bit: byte): boolean;
begin
 if (fbytes[bit div 8] and (1 shl (bit mod 8)))<>0 then exit(true)
 else exit(false);
end;

procedure TEv3Buttons.testButtons;
begin
  fpioctl(fi, EVIOCGKEY(sizeof(fbytes)), @fbytes);
end;

function TEv3Buttons.getBack: variant;
begin
 testbuttons;
 result:=testbit(bBack);
end;

function TEv3Buttons.getCenter: variant;
begin
  testbuttons;
  result:=testbit(bCenter);
end;

function TEv3Buttons.getDown: variant;
begin
  testbuttons;
  result:=testbit(bDown);
end;

function TEv3Buttons.getLeft: variant;
begin
  testbuttons;
  result:=testbit(bLeft);
end;

function TEv3Buttons.getRight: variant;
begin
  testbuttons;
  result:=testbit(bRight);
end;

function TEv3Buttons.getUp: variant;
begin
  testbuttons;
  result:=testbit(bUp);
end;

constructor TEv3Buttons.Create;
begin
  inherited create;
  fi:=fpopen('/dev/input/by-path/platform-gpio-keys.0-event',O_RDONLY);
end;

destructor TEv3Buttons.destroy;
begin
  fpclose(fi);
  inherited destroy;
end;

class function TEv3Buttons.varToButton(button: variant): integer;
begin
 case UTF8LowerCase(trim(button)) of
  'up','вверх','103':result:=bUP;
  'down','вниз','108':result:=bDown;
  'left','влево','105':result:=bLeft;
  'right','вправо','106':result:=bRight;
  'center','центр','28':result:=bCenter;
  'back','cancel','назад','отмена','14':result:=bBack;
  else result:=bBack;
 end;
end;

class function TEv3Buttons.ParseEvent(event: string; out Button: integer; out
  Press: boolean):string;
var
 b:integer; p:boolean;
begin
 b:=varToButton(extractWord(1,event,[':']));
 p:=varToYes(extractWord(2,event,[':']));
 button:=b;
 press:=p;
 result:=createEvent(b,p);
end;

function TEv3Buttons.waitEvent(event: string; timeout: dword): boolean;
 var butt:cint; push:boolean;
     res:boolean;
     dt:tdatetime;
begin
 parseEvent(event,butt,push);
// writeln(butt,' ',push);
 dt:=now();
 while true do begin
   testbuttons;
   res:=testbit(butt);
   //writeln(res,' ',push);
   if res=push then begin
      //writeln('yeeeeeeeesssssss'); readln;
    exit(true);
   end;
   if MilliSecondsBetween(now(),dt)>=timeout then exit(false);
   sleep(waitInterval);
 end;
end;

class function TEv3Buttons.createEvent(Button: integer; Press: boolean): string;
begin
  result:=intToStr(Button)+':'+intToStr(ord(Press));
end;

function TEv3Buttons.wait(out Button: variant; out Press:variant): TEv3Buttons;
type TButtonRec=packed record
      seconds,microseconds:dword;
      tp:word;
      code:word;
      value:dword;
     end;
  var ev3b:TButtonRec;
begin
 result:=self;
 repeat
    fpread(fi,ev3b,sizeof(ev3b));
 until ev3b.tp<>0;
 Button:=ev3b.code; Press:=boolean(ev3b.value);
end;

function TEv3Buttons.waitAll(Buttons: array of const): TEv3Buttons;
var o:array of TEv3; e:array of string;
    i:integer; R:TEv3;
begin
  result:=self;
  setlength(o,(High(Buttons)+1));
  setlength(e,(High(Buttons)+1));
  for i:=0 to high(Buttons) do begin
   o[i]:=self;
   e[i]:=arg2String(buttons[i]);
  end;
  waitEvents(o,e,evAND,R);
end;

function TEv3Buttons.waitAny(Buttons: array of const): TEv3Buttons;
var o:array of TEv3; e:array of string;
    i:integer; R:TEv3;
begin
  result:=self;
  setlength(o,(High(Buttons)+1));
  setlength(e,(High(Buttons)+1));
  for i:=0 to high(Buttons) do begin
   o[i]:=self;
   e[i]:=arg2String(buttons[i]);
  end;
  waitEvents(o,e,evOr,R);
end;

  procedure init; begin fpsystem('stty -echoctl'); ev3buttons:=Tev3buttons.Create; end;
  procedure done; begin ev3buttons.free; fpsystem('stty echoctl'); end;

initialization
   PushInit(@init);
   PushDone(@Done);
end.

